﻿using System.Threading.Tasks;
using ff14bot.Helpers;

namespace UltimaCR.Rotations
{
    public sealed partial class Summoner : Rotation
    {
        public override async Task<bool> Combat()
        {
            if (Ultima.UltSettings.SmartTarget)
            {
                //await MoveIntoRange();
                await YieldUnderXmilliseconds(100);
                await SetPet();
                if (await Aetherflow())
                {
                    Logging.Write("[Ultima] Aetherflow completed");
                    return true;
                }
                if (await DreadwyrmTrance())
                {
                    Logging.Write("[Ultima] DreadwyrmTrance completed");
                    return true;
                }
                if (await Bane())
                {
                    Logging.Write("[Ultima] Bane completed");
                    return true;
                }
                if (await Fester())
                {
                    Logging.Write("[Ultima] Fester completed");
                    return true;
                }
                if (await Deathflare())
                {
                    Logging.Write("[Ultima] Deathflare completed");
                    return true;
                }
                if (await Tridisaster())
                {
                    Logging.Write("[Ultima] Tridisaster completed");
                    return true;
                }
                if (await Rouse())
                {
                    Logging.Write("[Ultima] Rouse completed");
                    return true;
                }
                if (await Spur())
                {
                    Logging.Write("[Ultima] Spur completed");
                    return true;
                }
                if (await RagingStrikes())
                {
                    Logging.Write("[Ultima] RagingStrikes completed");
                    return true;
                }
                if (await Painflare())
                {
                    Logging.Write("[Ultima] Painflare completed");
                    return true;
                }
                if (await Enkindle())
                {
                    Logging.Write("[Ultima] Enkindle completed");
                    return true;
                }
                if (await SwiftRuinIII())
                {
                    Logging.Write("[Ultima] SwiftRuinIII completed");
                    return true;
                }
                if (await Contagion())
                {
                    Logging.Write("[Ultima] Contagion completed");
                    return true;
                }
                if (await RuinIII())
                {
                    Logging.Write("[Ultima] RuinIII completed");
                    return true;
                }
                if (await BioII())
                {
                    Logging.Write("[Ultima] BioII completed");
                    return true;
                }
                if (await Miasma())
                {
                    Logging.Write("[Ultima] Miasma completed");
                    return true;
                }
                if (await Bio())
                {
                    Logging.Write("[Ultima] Bio completed");
                    return true;
                }
                if (await MiasmaII())
                {
                    Logging.Write("[Ultima] MiasmaII completed");
                    return true;
                }
                if (await EnergyDrain())
                {
                    Logging.Write("[Ultima] EnergyDrain completed");
                    return true;
                }
                if (await ShadowFlare())
                {
                    Logging.Write("[Ultima] ShadowFlare completed");
                    return true;
                }
                if (await AerialSlash())
                {
                    Logging.Write("[Ultima] AerialSlash completed");
                    return true;
                }
                if (await RuinII())
                {
                    Logging.Write("[Ultima] RuinII completed");
                    return true;
                }
                if (ff14bot.Managers.Actionmanager.CanCast(MySpells.Ruin.Name, ff14bot.Core.Player.CurrentTarget))
                {
                    Logging.Write("[Ultima] Ruin completed");
                    return await Ruin();
                }
                return false;
            }
            if (Ultima.UltSettings.SingleTarget)
            {
                await YieldUnderXmilliseconds(100);
                await SetPet();
                if (await Aetherflow()) return true;
                if (await DreadwyrmTrance()) return true;
                if (await Fester()) return true;
                if (await Deathflare()) return true;
                if (await Tridisaster()) return true;
                if (await Rouse()) return true;
                if (await Spur()) return true;
                if (await RagingStrikes()) return true;
                if (await Enkindle()) return true;
                if (await SwiftRuinIII()) return true;
                if (await Contagion()) return true;
                if (await RuinIII()) return true;
                if (await BioII()) return true;
                if (await Miasma()) return true;
                if (await Bio()) return true;
                if (await EnergyDrain()) return true;
                if (await RuinII()) return true;
                return await Ruin();
            }
            if (Ultima.UltSettings.MultiTarget)
            {
                await YieldUnderXmilliseconds(100);
                await SetPet();
                if (await RagingStrikes()) return true;
                if (await BioII()) return true;
                if (await Miasma()) return true;
                if (await Bio()) return true;
                if (await MiasmaII()) return true;
                if (await Aetherflow()) return true;
                if (await EnergyDrain()) return true;
                if (await Contagion()) return true;
                if (await Bane()) return true;
                if (await ShadowFlare()) return true;
                if (await Rouse()) return true;
                if (await Spur()) return true;
                if (await Enkindle()) return true;
                if (await AerialSlash()) return true;
                if (await RuinII()) return true;
                return await Ruin();
            }
            return false;
        }

        public override async Task<bool> PVPRotation()
        {
            return false;
        }
    }
}